#include "find_sc_main.h"

#include<vector>

#include "../tools/misc.h"

bool
risc::traverser::is_sc_main(const SgFunctionDeclaration* function)
{
  return tools::is_func_name(function, "sc_main") && isSgGlobal(function->get_scope());
}

SgFunctionDeclaration*
risc::traverser::find_sc_main(SgNode* node)
{
  if (!node) {
    return 0;
  }

  SgFunctionDeclaration* temp = isSgFunctionDeclaration(node);
  if(temp) {
    if (is_sc_main(temp)) {
      return temp;
    }
  }

  std::vector<SgNode*> children = node->get_traversalSuccessorContainer();

  for (std::vector<SgNode*>::const_iterator i = children.begin();
      i != children.end(); ++i) {

    SgFunctionDeclaration* sc_main_decl = find_sc_main(*i);

    if (sc_main_decl) {
      // skip non-defining main() declaration, inspired by rose api
      if (sc_main_decl->get_definingDeclaration() == sc_main_decl) {
        return sc_main_decl;
      }
    }
  }
  return 0;
}
