#ifndef CLASS_H_INCLUDED_
#define CLASS_H_INCLUDED_

#include <string>

#include "rose.h"

#include "definition.h"


namespace risc {

class Class: public Definition {

public:

  /**
   * \brief Default constructor
   */
  explicit Class(SgClassDefinition *ast_node);

  /**
   * \brief  Returns the ast definition of the class
   * \return Pointer to the definition
   */
  SgClassDefinition* get_ast_node();

  /**
   * \brief  returns the name of the module definition
   */
  std::string get_name();

  /**
   * \brief  Returns the name of the module type
   * \return name of the module instance
   */
  virtual std::string get_ast_type_name();

private:
  /**
   * \brief Disabled copy constructor
   */
  Class(const Class &c);
};


} // end of namespace risc


#endif /* CLASS_H_INCLUDED_ */

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
