#ifndef CTHREAD_H_INCLUDED_
#define CTHREAD_H_INCLUDED_

#include <vector>

#include "rose.h"
#include "function.h"

namespace risc {

class CThread: public Function  {

public:

  /**
   * \brief Default constructor
   */
  explicit CThread(SgFunctionDefinition *ast_node);

private:
  /**
   * \brief Disabled copy constructor
   */
  CThread(const CThread &t);
};

typedef std::vector<CThread*> CThreadVector;
typedef std::vector<CThread*>::iterator CThreadVectorIter;
typedef std::vector<CThread*>::const_iterator CThreadVectorConstIter;

}; // end namespace risc

#endif /* CTHREAD_H_INCLUDED_ */

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
