#ifndef HIERARCHICAL_CHANNEL_H_INCLUDED_
#define HIERARCHICAL_CHANNEL_H_INCLUDED_

#include <vector>

#include "channel.h"
#include "rose.h"

namespace risc {

class HierarchicalChannel: public Channel{

public:

  /**
   * \brief Default constructor
   */
  explicit HierarchicalChannel(SgClassDefinition *ast_node);

private:
  /**
   * \brief Disabled copy constructor
   */
  HierarchicalChannel(const HierarchicalChannel &hcd);
};

typedef std::vector<HierarchicalChannel*> HierarchicalChannelVector;
typedef std::vector<HierarchicalChannel*>::iterator HierarchicalChannelVectorIter;
typedef std::vector<HierarchicalChannel*>::const_iterator HierarchicalChannelVectorConstIter;

}; // end of namespace risc

#endif /* HIERARCHICAL_CHANNEL_H_INCLUDED_ */

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
