#ifndef OBJECT_H_INCLUDED_
#define OBJECT_H_INCLUDED_

#include "definition.h"
#include "rose.h"

namespace risc {

class Object: public Definition {

public:

  /**
   * \brief default constructor
   */
  explicit Object(SgVariableDefinition *ast_node);

  /**
   * \brief  Returns the ast definition of the object
   * \return Pointer to the definition
   */
  SgVariableDefinition *get_ast_node();

  /**
   * \brief  Get function for the name of the module instance variable
   * \return Name as std::string
   */
  virtual std::string get_name();

private:

  /**
   * \brief Disabled copy constructor
   */
  Object(const Object &o);
};


} // end of namespace risc


#endif /* OBJECT_H_INCLUDED_ */

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
