#include "misc.h"

bool risc::tools::is_data_structure(SgType* type)
{
  switch(type->variant())
  {
    case T_CLASS:
    //case T_STRUCT: INFO: does not exists.
      return true;
      break;
    default:
      return false;
  }
}


bool risc::tools::is_builtin_type(SgType* type)
{
  // copied the fundamental types from
  // http://www.cplusplus.com/doc/tutorial/variables/

  switch(type->variant())
  {
    // character types (4)
    case T_CHAR:
    case T_WCHAR:

    //TODO
    //The types char16_t and char32_t are not defined

    // integer types signed types (5)
    case T_SIGNED_CHAR:
    case T_SIGNED_SHORT:
    case T_SIGNED_INT:
    case T_SIGNED_LONG:
    case T_SIGNED_LONG_LONG:

    // integer types unsigned types (5)
    case T_UNSIGNED_CHAR:
    case T_UNSIGNED_SHORT:
    case T_UNSIGNED_INT:
    case T_UNSIGNED_LONG:
    case T_UNSIGNED_LONG_LONG:

    // floating point types (3)
    case T_FLOAT:
    case T_DOUBLE:
    case T_LONG_DOUBLE:

    // special cases bool, void, null pointer (3)
    case T_BOOL:
    case T_VOID:


    // Rose specific
    case T_SHORT:
    case T_INT:
    case T_LONG:
    case T_LONG_LONG:

      return true;
      break;

    default:
      return false;
  }
}

bool risc::tools::class_types_are_identical(SgClassDefinition* cd1,
    SgClassDefinition* cd2)
{
  return cd1->get_declaration()->search_for_symbol_from_symbol_table() ==
    cd2->get_declaration()->search_for_symbol_from_symbol_table();
}

void risc::tools::print_indented(std::string s, unsigned indent)
{
  for(unsigned i=0; i<indent; i++) {
    std::cout << "  " << std::endl;
  }
  std::cout << s << std::endl;

}

bool
risc::tools::is_func_name(const SgFunctionDeclaration* function, const std::string& name)
{
  return function && function->get_name().getString() == name;
}

SgClassDefinition*
risc::tools::class_definition_of_variable(SgVariableDeclaration* var_decl)
{
  SgClassType* type = isSgClassType(var_decl->get_definition()->get_type());
  SgClassDeclaration* decl_stmt = isSgClassDeclaration(type->get_declaration());
  decl_stmt = isSgClassDeclaration(decl_stmt->get_definingDeclaration());
  SgClassDefinition* class_def = decl_stmt->get_definition();
  return class_def;
}

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
